/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the InternalTemplate type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &InternalTemplate{}

// InternalTemplate struct for InternalTemplate
type InternalTemplate struct {
	Text string `json:"text"`
}

// NewInternalTemplate instantiates a new InternalTemplate object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewInternalTemplate(text string) *InternalTemplate {
	this := InternalTemplate{}
	this.Text = text
	return &this
}

// NewInternalTemplateWithDefaults instantiates a new InternalTemplate object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewInternalTemplateWithDefaults() *InternalTemplate {
	this := InternalTemplate{}
	return &this
}

// GetText returns the Text field value
func (o *InternalTemplate) GetText() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Text
}

// GetTextOk returns a tuple with the Text field value
// and a boolean to check if the value has been set.
func (o *InternalTemplate) GetTextOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Text, true
}

// SetText sets field value
func (o *InternalTemplate) SetText(v string) {
	o.Text = v
}

func (o InternalTemplate) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o InternalTemplate) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["text"] = o.Text
	return toSerialize, nil
}

type NullableInternalTemplate struct {
	value *InternalTemplate
	isSet bool
}

func (v NullableInternalTemplate) Get() *InternalTemplate {
	return v.value
}

func (v *NullableInternalTemplate) Set(val *InternalTemplate) {
	v.value = val
	v.isSet = true
}

func (v NullableInternalTemplate) IsSet() bool {
	return v.isSet
}

func (v *NullableInternalTemplate) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableInternalTemplate(val *InternalTemplate) *NullableInternalTemplate {
	return &NullableInternalTemplate{value: val, isSet: true}
}

func (v NullableInternalTemplate) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableInternalTemplate) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


